Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_deallocation.cpp	(revision 56)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_deallocation.cpp	(revision 69)
@@ -31,56 +31,71 @@
     delete     in_NRESET;
 
-    delete     in_RESERVATION_STATION_IN_VAL         ;
-    delete    out_RESERVATION_STATION_IN_ACK         ;
-    delete     in_RESERVATION_STATION_IN_CONTEXT_ID  ;
-    delete     in_RESERVATION_STATION_IN_PACKET_ID   ;
-    delete     in_RESERVATION_STATION_IN_OPERATION   ;
-    delete     in_RESERVATION_STATION_IN_TYPE        ;
-    delete     in_RESERVATION_STATION_IN_HAS_IMMEDIAT;
-    delete     in_RESERVATION_STATION_IN_IMMEDIAT    ;
-//     delete     in_RESERVATION_STATION_IN_READ_RA     ;
-    delete     in_RESERVATION_STATION_IN_NUM_REG_RA  ;
-    delete     in_RESERVATION_STATION_IN_DATA_RA_VAL ;
-    delete     in_RESERVATION_STATION_IN_DATA_RA     ;
-//     delete     in_RESERVATION_STATION_IN_READ_RB     ;
-    delete     in_RESERVATION_STATION_IN_NUM_REG_RB  ;
-    delete     in_RESERVATION_STATION_IN_DATA_RB_VAL ;
-    delete     in_RESERVATION_STATION_IN_DATA_RB     ;
-//     delete     in_RESERVATION_STATION_IN_READ_RC     ;
-    delete     in_RESERVATION_STATION_IN_NUM_REG_RC  ;
-    delete     in_RESERVATION_STATION_IN_DATA_RC_VAL ;
-    delete     in_RESERVATION_STATION_IN_DATA_RC     ;
-    delete     in_RESERVATION_STATION_IN_WRITE_RD    ;
-    delete     in_RESERVATION_STATION_IN_NUM_REG_RD  ;
-    delete     in_RESERVATION_STATION_IN_WRITE_RE    ;
-    delete     in_RESERVATION_STATION_IN_NUM_REG_RE  ;
+    delete     in_INSERT_VAL           ;
+    delete    out_INSERT_ACK           ;
+    if (_param->_have_port_context_id)
+    delete     in_INSERT_CONTEXT_ID    ;
+    if (_param->_have_port_front_end_id)
+    delete     in_INSERT_FRONT_END_ID  ;
+    if (_param->_have_port_ooo_engine_id)
+    delete     in_INSERT_OOO_ENGINE_ID ;
+    if (_param->_have_port_rob_id)
+    delete     in_INSERT_ROB_ID        ;
+    delete     in_INSERT_OPERATION     ;
+    delete     in_INSERT_TYPE          ;
+    delete     in_INSERT_HAS_IMMEDIAT  ;
+    delete     in_INSERT_IMMEDIAT      ;
+//  delete     in_INSERT_READ_RA       ;
+    delete     in_INSERT_NUM_REG_RA    ;
+    delete     in_INSERT_DATA_RA_VAL   ;
+    delete     in_INSERT_DATA_RA       ;
+//  delete     in_INSERT_READ_RB       ;
+    delete     in_INSERT_NUM_REG_RB    ;
+    delete     in_INSERT_DATA_RB_VAL   ;
+    delete     in_INSERT_DATA_RB       ;
+//  delete     in_INSERT_READ_RC       ;
+    delete     in_INSERT_NUM_REG_RC    ;
+    delete     in_INSERT_DATA_RC_VAL   ;
+    delete     in_INSERT_DATA_RC       ;
+    delete     in_INSERT_WRITE_RD      ;
+    delete     in_INSERT_NUM_REG_RD    ;
+    delete     in_INSERT_WRITE_RE      ;
+    delete     in_INSERT_NUM_REG_RE    ;
     
-    delete [] out_RESERVATION_STATION_OUT_VAL         ;
-    delete []  in_RESERVATION_STATION_OUT_ACK         ;
-    delete [] out_RESERVATION_STATION_OUT_CONTEXT_ID  ;
-    delete [] out_RESERVATION_STATION_OUT_PACKET_ID   ;
-    delete [] out_RESERVATION_STATION_OUT_OPERATION   ;
-    delete [] out_RESERVATION_STATION_OUT_TYPE        ;
-    delete [] out_RESERVATION_STATION_OUT_HAS_IMMEDIAT;
-    delete [] out_RESERVATION_STATION_OUT_IMMEDIAT    ;
-    delete [] out_RESERVATION_STATION_OUT_DATA_RA     ;
-    delete [] out_RESERVATION_STATION_OUT_DATA_RB     ;
-    delete [] out_RESERVATION_STATION_OUT_DATA_RC     ;
-    delete [] out_RESERVATION_STATION_OUT_WRITE_RD    ;
-    delete [] out_RESERVATION_STATION_OUT_NUM_REG_RD  ;
-    delete [] out_RESERVATION_STATION_OUT_WRITE_RE    ;
-    delete [] out_RESERVATION_STATION_OUT_NUM_REG_RE  ;
+    delete [] out_RETIRE_VAL           ;
+    delete []  in_RETIRE_ACK           ;
+    if (_param->_have_port_context_id)
+    delete [] out_RETIRE_CONTEXT_ID    ;
+    if (_param->_have_port_front_end_id)
+    delete [] out_RETIRE_FRONT_END_ID  ;
+    if (_param->_have_port_ooo_engine_id)
+    delete [] out_RETIRE_OOO_ENGINE_ID ;
+    if (_param->_have_port_rob_id)
+    delete [] out_RETIRE_ROB_ID        ;
+    delete [] out_RETIRE_OPERATION     ;
+    delete [] out_RETIRE_TYPE          ;
+    delete [] out_RETIRE_HAS_IMMEDIAT  ;
+    delete [] out_RETIRE_IMMEDIAT      ;
+    delete [] out_RETIRE_DATA_RA       ;
+    delete [] out_RETIRE_DATA_RB       ;
+    delete [] out_RETIRE_DATA_RC       ;
+    delete [] out_RETIRE_WRITE_RD      ;
+    delete [] out_RETIRE_NUM_REG_RD    ;
+    delete [] out_RETIRE_WRITE_RE      ;
+    delete [] out_RETIRE_NUM_REG_RE    ;
     
-    delete []  in_GPR_WRITE_VAL       ;
-    delete []  in_GPR_WRITE_CONTEXT_ID;
-    delete []  in_GPR_WRITE_NUM_REG   ;
-    delete []  in_GPR_WRITE_DATA      ;
+    delete []  in_GPR_WRITE_VAL         ;
+    if (_param->_have_port_ooo_engine_id)
+    delete []  in_GPR_WRITE_OOO_ENGINE_ID;
+    delete []  in_GPR_WRITE_NUM_REG     ;
+    delete []  in_GPR_WRITE_DATA        ;
     
     delete []  in_SPR_WRITE_VAL       ;
-    delete []  in_SPR_WRITE_CONTEXT_ID;
+    if (_param->_have_port_ooo_engine_id)
+    delete []  in_SPR_WRITE_OOO_ENGINE_ID;
     delete []  in_SPR_WRITE_NUM_REG   ;
     delete []  in_SPR_WRITE_DATA      ;
     
-    delete []  in_BYPASS_WRITE_CONTEXT_ID ;
+    if (_param->_have_port_ooo_engine_id)
+    delete []  in_BYPASS_WRITE_OOO_ENGINE_ID;
     delete []  in_BYPASS_WRITE_GPR_VAL    ;
     delete []  in_BYPASS_WRITE_GPR_NUM_REG;
@@ -91,15 +106,20 @@
     
     delete []  in_BYPASS_MEMORY_VAL       ;
-    delete []  in_BYPASS_MEMORY_CONTEXT_ID;
+    if (_param->_have_port_ooo_engine_id)
+    delete []  in_BYPASS_MEMORY_OOO_ENGINE_ID;
     delete []  in_BYPASS_MEMORY_NUM_REG   ;
     delete []  in_BYPASS_MEMORY_DATA      ;
     
     // ~~~~~[ internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
-    delete []  internal_RESERVATION_STATION_OUT_VAL;
+    delete []  internal_RETIRE_VAL;
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
     delete    _component;
+#ifdef  SYSTEMC_VHDL_COMPATIBILITY
+    delete [] _queue_valid  ;
+#else
     delete    _queue_control;
+#endif
     delete [] _queue        ;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_end_cycle.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_end_cycle.cpp	(revision 69)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_end_cycle.cpp	(revision 69)
@@ -0,0 +1,46 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Reservation_station.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace multi_read_unit {
+namespace read_unit {
+namespace reservation_station {
+
+
+#undef  FUNCTION
+#define FUNCTION "Reservation_station::end_cycle"
+  void Reservation_station::end_cycle ()
+  {
+    log_printf(FUNC,Reservation_station,FUNCTION,"Begin");
+
+#ifdef STATISTICS
+    _stat->add();
+#endif    
+
+#ifdef VHDL_TESTBENCH
+    // Evaluation before read the ouput signal
+//     sc_start(0);
+    _interfaces->testbench();
+#endif
+    log_printf(FUNC,Reservation_station,FUNCTION,"End");
+  };
+
+}; // end namespace reservation_station
+}; // end namespace read_unit
+}; // end namespace multi_read_unit
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_genMoore.cpp	(revision 56)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_genMoore.cpp	(revision 69)
@@ -26,42 +26,86 @@
     log_printf(FUNC,Reservation_station,FUNCTION,"Begin");
 
-    // ~~~~~[ Interface "reservation_station_in" ]~~~~~~~~~~~~~~~~~~~~~~~~
+    // ~~~~~[ Interface "insert" ]~~~~~~~~~~~~~~~~~~~~~~~~
     
     // accept a new instructions when reservation_station is not full
-    internal_RESERVATION_STATION_IN_ACK = not _queue_control->full();
-    
-    PORT_WRITE(out_RESERVATION_STATION_IN_ACK, internal_RESERVATION_STATION_IN_ACK);
+#ifdef  SYSTEMC_VHDL_COMPATIBILITY
+    for (internal_INSERT_SLOT=0; (internal_INSERT_SLOT<_param->_size_queue) and (_queue_valid[internal_INSERT_SLOT]==true); internal_INSERT_SLOT++);
+    internal_INSERT_ACK = (internal_INSERT_SLOT<_param->_size_queue);
+#else
+    internal_INSERT_ACK = not _queue_control->full();
+#endif    
+    PORT_WRITE(out_INSERT_ACK, internal_INSERT_ACK);
 
-    // ~~~~~[ Interface "reservation_station_out" ]~~~~~~~~~~~~~~~~~~~~~~~
+    // ~~~~~[ Interface "retire" ]~~~~~~~~~~~~~~~~~~~~~~~
 
-    for (uint32_t i=0; i<_param->_size_queue; i++)
+    uint32_t nb_slot_find = 0;
+    for (uint32_t i=0; (
+#ifdef  SYSTEMC_VHDL_COMPATIBILITY
+			(i<_param->_size_queue) 
+#else
+			(i<_queue_control->nb_elt())
+#endif
+			and (nb_slot_find < _param->_nb_inst_retire)
+
+			)
+			; i++)
       {
-	bool     val   = i <_queue_control->nb_elt();
-	uint32_t index = (*_queue_control)[i];
-	
+	uint32_t index;
+#ifdef  SYSTEMC_VHDL_COMPATIBILITY
+	index = i;
+#else
+	index = (*_queue_control)[i];
+#endif
+	bool     val   = 
+	  (
+#ifdef  SYSTEMC_VHDL_COMPATIBILITY
+	   _queue_valid [i]           and
+#endif
+	   _queue[index]._data_ra_val and 
+	   _queue[index]._data_rb_val and 
+	   _queue[index]._data_rc_val);
+
 	if (val == true)
 	  {
-	    // valid if all data is present
- 	    val = (_queue[index]._data_ra_val and 
-		   _queue[index]._data_rb_val and 
-		   _queue[index]._data_rc_val);
+	    internal_RETIRE_SLOT [nb_slot_find] = i;
+	    nb_slot_find ++;
+	  }
+      }
 
-	    PORT_WRITE(out_RESERVATION_STATION_OUT_CONTEXT_ID  [index],_queue[index]._context_id);
-	    PORT_WRITE(out_RESERVATION_STATION_OUT_PACKET_ID   [index],_queue[index]._packet_id);
-	    PORT_WRITE(out_RESERVATION_STATION_OUT_OPERATION   [index],_queue[index]._operation);
-	    PORT_WRITE(out_RESERVATION_STATION_OUT_TYPE        [index],_queue[index]._type);
-	    PORT_WRITE(out_RESERVATION_STATION_OUT_HAS_IMMEDIAT[index],_queue[index]._has_immediat);
-	    PORT_WRITE(out_RESERVATION_STATION_OUT_IMMEDIAT    [index],_queue[index]._immediat);
-	    PORT_WRITE(out_RESERVATION_STATION_OUT_DATA_RA     [index],_queue[index]._data_ra);
-	    PORT_WRITE(out_RESERVATION_STATION_OUT_DATA_RB     [index],_queue[index]._data_rb);
-	    PORT_WRITE(out_RESERVATION_STATION_OUT_DATA_RC     [index],_queue[index]._data_rc);
-	    PORT_WRITE(out_RESERVATION_STATION_OUT_WRITE_RD    [index],_queue[index]._write_rd);
-	    PORT_WRITE(out_RESERVATION_STATION_OUT_NUM_REG_RD  [index],_queue[index]._num_reg_rd);
-	    PORT_WRITE(out_RESERVATION_STATION_OUT_WRITE_RE    [index],_queue[index]._write_re);
-	    PORT_WRITE(out_RESERVATION_STATION_OUT_NUM_REG_RE  [index],_queue[index]._num_reg_re);
+    for (uint32_t i=0; i<_param->_nb_inst_retire; i++)
+      {
+	bool val                = i<nb_slot_find;
+	internal_RETIRE_VAL [i] = val;
+
+	PORT_WRITE(out_RETIRE_VAL [i], val);
+
+	if (val)
+	  {
+	    uint32_t index;
+#ifdef  SYSTEMC_VHDL_COMPATIBILITY
+	    index = internal_RETIRE_SLOT [i];
+#else
+	    index = (*_queue_control)[internal_RETIRE_SLOT [i]];
+#endif
+	    if (_param->_have_port_context_id)
+	    PORT_WRITE(out_RETIRE_CONTEXT_ID    [i],_queue[index]._context_id);
+	    if (_param->_have_port_front_end_id)
+	    PORT_WRITE(out_RETIRE_FRONT_END_ID  [i],_queue[index]._front_end_id);
+	    if (_param->_have_port_ooo_engine_id)
+	    PORT_WRITE(out_RETIRE_OOO_ENGINE_ID [i],_queue[index]._ooo_engine_id);
+	    if (_param->_have_port_rob_id)
+	    PORT_WRITE(out_RETIRE_ROB_ID        [i],_queue[index]._rob_id);
+	    PORT_WRITE(out_RETIRE_OPERATION     [i],_queue[index]._operation);
+	    PORT_WRITE(out_RETIRE_TYPE          [i],_queue[index]._type);
+	    PORT_WRITE(out_RETIRE_HAS_IMMEDIAT  [i],_queue[index]._has_immediat);
+	    PORT_WRITE(out_RETIRE_IMMEDIAT      [i],_queue[index]._immediat);
+	    PORT_WRITE(out_RETIRE_DATA_RA       [i],_queue[index]._data_ra);
+	    PORT_WRITE(out_RETIRE_DATA_RB       [i],_queue[index]._data_rb);
+	    PORT_WRITE(out_RETIRE_DATA_RC       [i],_queue[index]._data_rc);
+	    PORT_WRITE(out_RETIRE_WRITE_RD      [i],_queue[index]._write_rd);
+	    PORT_WRITE(out_RETIRE_NUM_REG_RD    [i],_queue[index]._num_reg_rd);
+	    PORT_WRITE(out_RETIRE_WRITE_RE      [i],_queue[index]._write_re);
+	    PORT_WRITE(out_RETIRE_NUM_REG_RE    [i],_queue[index]._num_reg_re);
 	  }
-	
-	internal_RESERVATION_STATION_OUT_VAL [index] = val;
-	PORT_WRITE(out_RESERVATION_STATION_OUT_VAL [index], internal_RESERVATION_STATION_OUT_VAL [index]);
       }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_transition.cpp	(revision 56)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_transition.cpp	(revision 69)
@@ -19,4 +19,25 @@
 namespace reservation_station {
 
+#ifdef  SYSTEMC_VHDL_COMPATIBILITY
+#define dump_queue() \
+  do\
+  {\
+   log_printf(TRACE,Reservation_station,FUNCTION," * dump queue");\
+   log_printf(TRACE,Reservation_station,FUNCTION,"   * nb_elt : %d",_queue_nb_elt);\
+   for (uint32_t j=0;j<_param->_size_queue; j++)\
+   {\
+     cout << "\t"\
+          << "[" << j << "] "\
+          << "{" << _queue[j]._rob_id << " - "<< _queue[j]._context_id << "} " << " - "<< _queue[j]._front_end_id << "} " << " - "<< _queue[j]._ooo_engine_id << "} "\
+          << _queue[j]._data_ra_val << ", "\
+          << _queue[j]._num_reg_ra  << " - "\
+          << _queue[j]._data_rb_val << ","\
+          << _queue[j]._num_reg_rb  << " - "\
+          << _queue[j]._data_rc_val << ","\
+          << _queue[j]._num_reg_rc  \
+          << endl;\
+    }\
+  } while (0) 
+#else
 #define dump_queue() \
   do\
@@ -28,5 +49,5 @@
      cout << "\t"\
           << "[" << (*_queue_control)[j] << "] "\
-          << "{" << _queue[(*_queue_control)[j]]._packet_id << " - "<< _queue[(*_queue_control)[j]]._context_id << "} "\
+          << "{" << _queue[(*_queue_control)[j]]._rob_id << " - "<< _queue[(*_queue_control)[j]]._context_id << "} " << " - "<< _queue[(*_queue_control)[j]]._front_end_id << "} " << " - "<< _queue[(*_queue_control)[j]]._ooo_engine_id << "} "\
           << _queue[(*_queue_control)[j]]._data_ra_val << ", "\
           << _queue[(*_queue_control)[j]]._num_reg_ra  << " - "\
@@ -38,4 +59,5 @@
     }\
   } while (0) 
+#endif
 
 #undef  FUNCTION
@@ -47,58 +69,33 @@
     if (PORT_READ(in_NRESET) == 0)
       {
+#ifdef  SYSTEMC_VHDL_COMPATIBILITY
+	for (uint32_t i=0; i<_param->_size_queue; i++)
+	  _queue_valid [i] = false;
+#else
 	_queue_control->clear();
+#endif
       }
     else
       {
-	// ***** PUSH to reservation station
-	if ((PORT_READ(in_RESERVATION_STATION_IN_VAL) == 1) and
-	    (    internal_RESERVATION_STATION_IN_ACK  == 1))
+	// ***** POP from reservation station
+
+	// scan in reverse order, because when we pop the queue there are an auto reorder
+	//for (int32_t i=(static_cast<int32_t>(_queue_control->nb_elt()))-1;i>=0; i--)
+	for (int32_t i=(static_cast<int32_t>(_param->_nb_inst_retire))-1;i>=0; i--)
 	  {
-	    log_printf(TRACE,Reservation_station,FUNCTION,"PUSH");
-
-	    // Write in reservation station
-	    uint32_t index = _queue_control->push();
-
-	    log_printf(TRACE,Reservation_station,FUNCTION," * index         : %d",index);
-
-  	    _queue[index]._context_id   = PORT_READ(in_RESERVATION_STATION_IN_CONTEXT_ID  );
-  	    _queue[index]._packet_id    = PORT_READ(in_RESERVATION_STATION_IN_PACKET_ID   );
-  	    _queue[index]._operation    = PORT_READ(in_RESERVATION_STATION_IN_OPERATION   );
-  	    _queue[index]._type         = PORT_READ(in_RESERVATION_STATION_IN_TYPE        );
-  	    _queue[index]._has_immediat = PORT_READ(in_RESERVATION_STATION_IN_HAS_IMMEDIAT);
-  	    _queue[index]._immediat     = PORT_READ(in_RESERVATION_STATION_IN_IMMEDIAT    );
-//	    _queue[index]._read_ra      = PORT_READ(in_RESERVATION_STATION_IN_READ_RA     );
-  	    _queue[index]._num_reg_ra   = PORT_READ(in_RESERVATION_STATION_IN_NUM_REG_RA  );
-  	    _queue[index]._data_ra_val  = PORT_READ(in_RESERVATION_STATION_IN_DATA_RA_VAL );
-  	    _queue[index]._data_ra      = PORT_READ(in_RESERVATION_STATION_IN_DATA_RA     );
-//	    _queue[index]._read_rb      = PORT_READ(in_RESERVATION_STATION_IN_READ_RB     );
-  	    _queue[index]._num_reg_rb   = PORT_READ(in_RESERVATION_STATION_IN_NUM_REG_RB  );
-  	    _queue[index]._data_rb_val  = PORT_READ(in_RESERVATION_STATION_IN_DATA_RB_VAL );
-  	    _queue[index]._data_rb      = PORT_READ(in_RESERVATION_STATION_IN_DATA_RB     );
-//	    _queue[index]._read_rc      = PORT_READ(in_RESERVATION_STATION_IN_READ_RC     );
-  	    _queue[index]._num_reg_rc   = PORT_READ(in_RESERVATION_STATION_IN_NUM_REG_RC  );
-  	    _queue[index]._data_rc_val  = PORT_READ(in_RESERVATION_STATION_IN_DATA_RC_VAL );
-  	    _queue[index]._data_rc      = PORT_READ(in_RESERVATION_STATION_IN_DATA_RC     );
-  	    _queue[index]._write_rd     = PORT_READ(in_RESERVATION_STATION_IN_WRITE_RD    );
-  	    _queue[index]._num_reg_rd   = PORT_READ(in_RESERVATION_STATION_IN_NUM_REG_RD  );
-  	    _queue[index]._write_re     = PORT_READ(in_RESERVATION_STATION_IN_WRITE_RE    );
-  	    _queue[index]._num_reg_re   = PORT_READ(in_RESERVATION_STATION_IN_NUM_REG_RE  );
-// 	    dump_queue();
-	  }
-
-	// ***** POP from reservation station
-
-	// scan in reverse order, because when we pop the queue there are an auto reorder
-	for (int32_t i=(static_cast<int32_t>(_queue_control->nb_elt()))-1;i>=0; i--)
-	  {
-	    uint32_t index = (*_queue_control)[i];
-	    
-	    if ((    internal_RESERVATION_STATION_OUT_VAL [index]  == 1) and
-		(PORT_READ(in_RESERVATION_STATION_OUT_ACK [index]) == 1))
-	      {
+	    if ((    internal_RETIRE_VAL [i]  == 1) and
+		(PORT_READ(in_RETIRE_ACK [i]) == 1))
+	      {
+		//uint32_t index = (*_queue_control)[i];
+
 		log_printf(TRACE,Reservation_station,FUNCTION,"POP  [%d]",i);
 
-		_queue_control->pop(i);
-
+		uint32_t index  = internal_RETIRE_SLOT[i];
+
+#ifdef  SYSTEMC_VHDL_COMPATIBILITY
+		_queue_valid [index] = false;
+#else
+		_queue_control->pop(index);
+#endif
 		log_printf(TRACE,Reservation_station,FUNCTION," * index         : %d",index);
 // 		dump_queue();
@@ -110,13 +107,29 @@
 	
 	// scan all entry
-	for (uint32_t i=0; i<_queue_control->nb_elt(); i++)
+	for (uint32_t i=0; 
+#ifdef  SYSTEMC_VHDL_COMPATIBILITY
+	     i<_param->_size_queue;
+#else
+	     i<_queue_control->nb_elt();
+#endif
+	     i++)
 	  {
-	    uint32_t index = (*_queue_control)[i];
+	    uint32_t index;
+#ifdef  SYSTEMC_VHDL_COMPATIBILITY
+	    index = i;
+#else
+	    index = (*_queue_control)[i];
+#endif
 
 	    // ***** bypass - gpr_write
 	    for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
 	      {
-		if ((PORT_READ(in_GPR_WRITE_VAL        [j]) == 1) and
-		    (PORT_READ(in_GPR_WRITE_CONTEXT_ID [j]) == _queue[index]._context_id))
+		bool cmp;
+		if (_param->_have_port_ooo_engine_id)
+		  cmp = (PORT_READ(in_GPR_WRITE_OOO_ENGINE_ID [j]) == _queue[index]._ooo_engine_id);
+		else
+		  cmp = true;
+
+		if ((PORT_READ(in_GPR_WRITE_VAL        [j]) == 1) and cmp)
 		  {
 		    if (PORT_READ(in_GPR_WRITE_NUM_REG [j]) == _queue[index]._num_reg_ra)
@@ -137,7 +150,13 @@
 	    for (uint32_t j=0; j<_param->_nb_spr_write; j++)
 	      {
-		if ((PORT_READ(in_SPR_WRITE_VAL        [j]) == 1)                         and
-		    (PORT_READ(in_SPR_WRITE_CONTEXT_ID [j]) == _queue[index]._context_id) and
-		    (PORT_READ(in_SPR_WRITE_NUM_REG    [j]) == _queue[index]._num_reg_rc))
+		bool cmp;
+		if (_param->_have_port_ooo_engine_id)
+		  cmp = (PORT_READ(in_SPR_WRITE_OOO_ENGINE_ID [j]) == _queue[index]._ooo_engine_id);
+		else
+		  cmp = true;
+		
+		if ((PORT_READ(in_SPR_WRITE_VAL           [j]) == 1) and
+		    cmp and
+		    (PORT_READ(in_SPR_WRITE_NUM_REG       [j]) == _queue[index]._num_reg_rc))
 		  {
 		    log_printf(TRACE,Reservation_station,FUNCTION," -> SPR_WRITE     [%d] - Hit queue[%d]-SPR_RC[%d]",i,index,_queue[index]._num_reg_rc);
@@ -149,5 +168,11 @@
 	    for (uint32_t j=0; j<_param->_nb_bypass_write; j++)
 	      {
-		if (PORT_READ(in_BYPASS_WRITE_CONTEXT_ID [j]) == _queue[index]._context_id)
+		bool cmp;
+		if (_param->_have_port_ooo_engine_id)
+		  cmp = (PORT_READ(in_BYPASS_WRITE_OOO_ENGINE_ID [j]) == _queue[index]._ooo_engine_id);
+		else
+		  cmp = true;
+
+		if (cmp)
 		  {
 		    if (PORT_READ(in_BYPASS_WRITE_GPR_VAL    [j]) == 1)
@@ -178,6 +203,11 @@
 	    for (uint32_t j=0; j<_param->_nb_bypass_memory; j++)
 	      {
-		if ((PORT_READ(in_BYPASS_MEMORY_VAL        [j]) == 1) and
-		    (PORT_READ(in_BYPASS_MEMORY_CONTEXT_ID [j]) == _queue[index]._context_id))
+		bool cmp;
+		if (_param->_have_port_ooo_engine_id)
+		  cmp = (PORT_READ(in_BYPASS_MEMORY_OOO_ENGINE_ID [j]) == _queue[index]._ooo_engine_id);
+		else
+		  cmp = true;
+
+		if ((PORT_READ(in_BYPASS_MEMORY_VAL           [j]) == 1) and cmp)
 		  {
 		    if (PORT_READ(in_BYPASS_MEMORY_NUM_REG [j]) == _queue[index]._num_reg_ra)
@@ -196,13 +226,54 @@
 	      }
 	  }
+	// ***** PUSH to reservation station
+	if ((PORT_READ(in_INSERT_VAL) == 1) and
+	    (    internal_INSERT_ACK  == 1))
+	  {
+	    log_printf(TRACE,Reservation_station,FUNCTION,"PUSH");
+
+	    // Write in reservation station
+	    uint32_t index;
+
+#ifdef  SYSTEMC_VHDL_COMPATIBILITY
+	    index = internal_INSERT_SLOT;
+	    _queue_valid [internal_INSERT_SLOT] = true;
+#else
+	    index = _queue_control->push();
+#endif
+	    log_printf(TRACE,Reservation_station,FUNCTION," * index         : %d",index);
+
+  	    if (_param->_have_port_context_id)
+	    _queue[index]._context_id      = PORT_READ(in_INSERT_CONTEXT_ID     );
+  	    if (_param->_have_port_front_end_id)
+	    _queue[index]._front_end_id    = PORT_READ(in_INSERT_FRONT_END_ID   );
+  	    if (_param->_have_port_ooo_engine_id)
+	    _queue[index]._ooo_engine_id   = PORT_READ(in_INSERT_OOO_ENGINE_ID  );
+  	    if (_param->_have_port_rob_id)
+	    _queue[index]._rob_id          = PORT_READ(in_INSERT_ROB_ID         );
+  	    _queue[index]._operation       = PORT_READ(in_INSERT_OPERATION      );
+  	    _queue[index]._type            = PORT_READ(in_INSERT_TYPE           );
+  	    _queue[index]._has_immediat    = PORT_READ(in_INSERT_HAS_IMMEDIAT   );
+  	    _queue[index]._immediat        = PORT_READ(in_INSERT_IMMEDIAT       );
+//	    _queue[index]._read_ra         = PORT_READ(in_INSERT_READ_RA        );
+  	    _queue[index]._num_reg_ra      = PORT_READ(in_INSERT_NUM_REG_RA     );
+  	    _queue[index]._data_ra_val     = PORT_READ(in_INSERT_DATA_RA_VAL    );
+  	    _queue[index]._data_ra         = PORT_READ(in_INSERT_DATA_RA        );
+//	    _queue[index]._read_rb         = PORT_READ(in_INSERT_READ_RB        );
+  	    _queue[index]._num_reg_rb      = PORT_READ(in_INSERT_NUM_REG_RB     );
+  	    _queue[index]._data_rb_val     = PORT_READ(in_INSERT_DATA_RB_VAL    );
+  	    _queue[index]._data_rb         = PORT_READ(in_INSERT_DATA_RB        );
+//	    _queue[index]._read_rc         = PORT_READ(in_INSERT_READ_RC        );
+  	    _queue[index]._num_reg_rc      = PORT_READ(in_INSERT_NUM_REG_RC     );
+  	    _queue[index]._data_rc_val     = PORT_READ(in_INSERT_DATA_RC_VAL    );
+  	    _queue[index]._data_rc         = PORT_READ(in_INSERT_DATA_RC        );
+  	    _queue[index]._write_rd        = PORT_READ(in_INSERT_WRITE_RD       );
+  	    _queue[index]._num_reg_rd      = PORT_READ(in_INSERT_NUM_REG_RD     );
+  	    _queue[index]._write_re        = PORT_READ(in_INSERT_WRITE_RE       );
+  	    _queue[index]._num_reg_re      = PORT_READ(in_INSERT_NUM_REG_RE     );
+// 	    dump_queue();
+	  }
       }
 
-#ifdef STATISTICS
-    _stat->add();
-#endif    
-
-#ifdef VHDL_TESTBENCH
-    vhdl_testbench_transition ();
-#endif
+    end_cycle ();
 
     log_printf(FUNC,Reservation_station,FUNCTION,"End");
